<?php
/**
 * @copyright (c) Kufer Software GmbH, Oderstraße 7, D-84453 Mühldorf
 */

namespace Kufer\Web\KuferTools\Hausmeister\Raumbelegung\Veranstaltungsplanung;

class VeranstaltungsplanungController extends \Kufer\Web\KuferTools\Basis\Controller\ToolController
{
  private $emailSuccess;
  private $veranstaltungsplanung;

  public function __construct($emailSuccess = null, $veranstaltungsplanung = null)
  {
    $this->emailSuccess = $emailSuccess;
    $this->veranstaltungsplanung = (!is_null($veranstaltungsplanung)) ? $veranstaltungsplanung : new \Datamodul();
  }

  protected function getUseCase(): \Kufer\Web\KuferTools\Basis\UseCase\UseCase
  {
    return new VeranstaltungsplanungUseCase(
      $this->getRequestObj()
    );
  }

  protected function getRequestObj()
  {
    $requestObj = new VeranstaltungsplanungRequest();
    $requestObj->emailSuccess = $this->emailSuccess;
    $requestObj->veranstaltungsplanung = $this->veranstaltungsplanung;

    return $requestObj;
  }

  protected function getPresenter($pUseCaseResponse)
  {
    return new VeranstaltungsplanungPresenter($pUseCaseResponse);
  }
}